#include <stdio.h>
#include <stdlib.h>
#include "gui.h"

static int
Bget (char *data, int x, int y, int bytes_per_line)
{
  char *byte = data + y*bytes_per_line + (x >> 3);
  return (*byte & (1 << (x & 7)));
}

static void
Bset (char *data, int x, int y, int bytes_per_line)
{
  char *byte = data + y*bytes_per_line + (x >> 3);
  *byte |= (1 << (x & 7));
}

static void
Bclr (char *data, int x, int y, int bytes_per_line)
{
  char *byte = data + y*bytes_per_line + (x >> 3);
  *byte &= ~(1 << (x & 7));
}

void
Calc (char *data, int w, int h, int steps)
{
  int i, x, y, n, bytes_per_line;
  char *maps[2];

  bytes_per_line = (w+7)/8;

  maps[0] = malloc (bytes_per_line*h);
  maps[1] = malloc (bytes_per_line*h);

  memcpy (maps[0], data, bytes_per_line*h);
  memcpy (maps[1], data, bytes_per_line*h);

  for (i = 0; i < steps; ++i) {
    ShowBitmap (maps[i&1], w, h, 0, 0);
    FlushBitmap ();
    for (x = 1; x < w-1; ++x) {
      for (y = 1; y < h-1; ++y) {
	n  = !!Bget (maps[i&1], x-1, y-1, bytes_per_line);
	n += !!Bget (maps[i&1], x,   y-1, bytes_per_line);
	n += !!Bget (maps[i&1], x+1, y-1, bytes_per_line);
	n += !!Bget (maps[i&1], x-1, y,   bytes_per_line);
	n += !!Bget (maps[i&1], x+1, y,   bytes_per_line);
	n += !!Bget (maps[i&1], x-1, y+1, bytes_per_line);
	n += !!Bget (maps[i&1], x,   y+1, bytes_per_line);
	n += !!Bget (maps[i&1], x+1, y+1, bytes_per_line);

	if (n < 2 || n > 3)
	  Bclr (maps[(i+1)&1], x, y, bytes_per_line);
	else if (n == 3)
	  Bset (maps[(i+1)&1], x, y, bytes_per_line);
	else if (Bget (maps[i&1], x, y, bytes_per_line))
	  Bset (maps[(i+1)&1], x, y, bytes_per_line);
	else
	  Bclr (maps[(i+1)&1], x, y, bytes_per_line);
      }
    }
    Warte (Verzoegerung);
  }
  ShowBitmap (maps[i&1], w, h, 0, 0);
  FlushBitmap ();
}


