
#include <stdio.h>
#include <stdlib.h>

static char *part1="\
component A[i] { code master.z;\n\
		 puid /Cluster/00;\n\
			streams  , , , ,\n\
				<| rlo{0},   >| rli{0},\n\
				<| rli{i},   >| rlo{i},\n\
";

static char *rep="\
				<| mao{%d},   >| mai{%d}%c\n\
";

static char *part2="\
		 ;\n\
		}\n\
\n\
component B[i] { code slave.z;\n\
			streams <| rli{i},   >| rlo{i}, , ,\n\
				<| rlo{i+1}, >| rli{i+1},\n\
				<| mai{i},   >| mao{i}\n\
		 ;\n\
		}\n\
\n\
A{$1} [i < $1] ^^ B{i}\n\
";

int main (int argc, char *argv[])
{
    int index, procs;

    if (argc != 2 || ((procs = atoi (argv[1])) < 1)) {
	fprintf (stderr, "usage:\n\t%s <no of slaves>\n", argv[0]);
	exit (1);
    }
    printf ("%s", part1);
    for (index=0; index<procs; index++)
      printf (rep, index, index, (index==procs-1)?' ':',');
    printf ("%s", part2);
    fprintf(stderr, "cdl -o life.z life.cdl %d\n", procs);
    return 0;
}
