#include <stdio.h>
#include <time.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <signal.h>
#include "lifecalc.h"
#include "PsxIO.h"
#include "comm.h"

/*
 * Kanaele
 */

#define RING_LIN	0	/* links  in  den Prozessor rein */
#define RING_LOUT	1	/* links  aus dem Prozessor raus */
#define RING_RIN	4	/* rechts in  den Prozessor rein */
#define RING_ROUT	5	/* rechts aus dem Prozessor raus */
#define MAST_IN		6	/* vom Master                    */
#define MAST_OUT	7	/* zum Master                    */

int    prozessnr = 0;
bmsize thesize;

#define SEND(o,x,l,c) { \
			int xyz; \
			xyz = PsxWrite (o, (char *) (x), l); \
			if (xyz != l) { \
			  fprintf (stderr, "Fatal error slave %d(%d): %d supposed %d errno=%d\n", \
				   prozessnr, __LINE__, xyz, l, errno); \
			  c; \
			} \
		  };

#define RECV(i,x,l,c) { \
		        int xyz; \
			xyz = PsxRead (i, (char *) (x), l); \
			if (xyz != l) { \
			  fprintf (stderr, "Fatal error slave %d(%d): %d supposed %d errno=%d\n", \
				   prozessnr, __LINE__, xyz, l, errno); \
			  c; \
			} \
		  };

int RingUpdate (void)
{
    /*
     * Als naechstes folgt ein Ring-Update
     */
    
    RECV (RING_LIN,
	  BFieldCurrentAddress,
	  thesize.lofl,
	  return 1);
    SEND (RING_LOUT,
	  BFieldCurrentAddress + thesize.lofl,
	  thesize.lofl,
	  return 1);
    SEND (RING_ROUT,
	  BFieldCurrentAddress + (thesize.ysize * thesize.lofl),
	  thesize.lofl,
	  return 1);
    RECV (RING_RIN,
	  BFieldCurrentAddress + (thesize.ysize + 1) * thesize.lofl,
	  thesize.lofl,
	  return 1);
    
    return 0;
}

int main (void)
{
    comm mycomm;
    int index;

    /*
     * zuerst muessen wir wissen wer wir sind
     */

    RECV (RING_LIN,  &mycomm, sizeof (comm), ;);

 init_again:
    prozessnr = mycomm.prozessor++;
    SEND (RING_ROUT, &mycomm, sizeof (comm), return 1);

    if (mycomm.command == QUIT)
      return 0;

    BSetSlaveID(prozessnr);

    /*
     * Jetzt kommt ein Paket mit den Informationen, wie gross
     * unsere Bitmap ist
     */
    RECV (MAST_IN, &thesize, sizeof (bmsize), return 1);

    /*
     * TODO: Fehlerhandling
     */
    if (BSet () != 1) {
	fprintf (stderr, "Prozess %02d konnte Bitmap nicht allokieren.\n",
		 prozessnr);
	exit (1);
    }

    /*
     * Jetzt bekommen wir unsere Bitmap
     */
    RECV (MAST_IN,
	  BFieldCurrentAddress + thesize.lofl,
	  thesize.length,
	  return 1);

    /*
     * Als naechstes folgt ein Ring-Update
     */
    RingUpdate ();

    while (1) {
	/*
	 * Warte auf GO!
	 */
	RECV (RING_LIN,
	      &mycomm,
	      sizeof (comm),
	      return 1);
	
	if (mycomm.command == COUNT) {
	    BEnd();
	    goto init_again;
	}
	
	SEND (RING_ROUT,
	      &mycomm,
	      sizeof (comm),
	      return 1);
	
	if (mycomm.command == QUIT)
	  break;
	
	if (mycomm.BirthMin != -1)
	  BSetRules (mycomm.SurviveMin,
		     mycomm.SurviveMax,
		     mycomm.BirthMin,
		     mycomm.BirthMax);
	
	/*
	 * Schleife
	 */
	
	for (index=0; index<mycomm.steps; index++) {
	    /*
	     * TODO: Abfrage ob Bitmap leer ist
	     */
	    BCalc ();

	    /*
	     * Ringupdate links
	     */

	    RECV (RING_LIN,
		  BFieldCurrentAddress,
		  thesize.lofl,
		  return 1);
	    SEND (RING_LOUT,
		  BFieldCurrentAddress + thesize.lofl,
		  thesize.lofl,
		  return 1);
	    
	    /*
	     * Versende Bitmap an Master
	     */

	    SEND (MAST_OUT,
		  BFieldCurrentAddress + thesize.lofl,
		  thesize.length,
		  return 1);

	    /*
	     * Ringupdate rechts
	     */
	    SEND (RING_ROUT,
		  BFieldCurrentAddress + (thesize.ysize * thesize.lofl),
		  thesize.lofl,
		  return 1);
	    RECV (RING_RIN,
		  BFieldCurrentAddress + (thesize.ysize + 1) * thesize.lofl,
		  thesize.lofl,
		  return 1);
	} /* for */
    } /* while (1) */

    BEnd ();
}
